
package de.ivu.elect.presentation.dokumente;

import java.io.ByteArrayInputStream;
import java.util.List;

import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import org.primefaces.model.DefaultStreamedContent;
import org.primefaces.model.StreamedContent;

import de.ivu.elect.business.dokumente.boundary.DefaultDokumentVorlagenInit;
import de.ivu.elect.business.dokumente.boundary.DokumentVorlageEdit;
import de.ivu.elect.business.dokumente.entity.DokumentArchiveUploadResultEntry;
import de.ivu.elect.business.dokumente.entity.DokumentVorlage;
import de.ivu.elect.business.dokumente.entity.DokumentVorlageConstants;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.jee.presentation.search.AbstractSearchParameters;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId("174")
@Named(AbstractDokumentVorlageSearchView.COMPONENT_NAME)
public class DokumentVorlageSearchView extends AbstractDokumentVorlageSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient DokumentVorlageEdit dokumentVorlageEdit;

  @Inject
  private transient DefaultDokumentVorlagenInit defaultDokumentVorlagenInit;

  public DokumentVorlageSearchView() {
    super();
  }

  @Override
  protected AbstractGebietSecurityFilter<DokumentVorlage> getGebietSecurityFilter() {
    return KEIN_GEBIET_SECURITY_FILTER;
  }

  public boolean isBtnDeleteAllRendered() {
    return hasPermission(UseCasePermission.DOKUMENT_VORLAGE_DELETE);
  }

  public boolean isBtnDeleteAllDisabled() {
    return isEmptySearchResultDisplayed();
  }


  @Nullable
  @PreConditionCheck
  public String checkCondition() {
    // ELECT-7469
    if (!isWahlSelected() && !isWahlterminSelected()) {
      return getStartViewId();
    }

    return null;
  }


  @Redirect
  @UseCaseSecure(UseCasePermission.DOKUMENT_VORLAGE_DELETE)
  public String deleteAll() {
    List<DokumentVorlage> dokumentVorlagen = getSearchResult();

    dokumentVorlageEdit.deleteAll(dokumentVorlagen);

    addInfoMessage("entity.edit.action.delete.all.success.message", entityMeta.getMehrzahlMessage());

    resetSearchResult();

    return getViewId();
  }

  public boolean isBtnDownloadAllRendered() {
    // Cf. DokumentVorlageDownloadAction#getRequiredPermission
    return hasPermission(UseCasePermission.DOKUMENT_VORLAGE_SEARCH);
  }

  public boolean isBtnStandardZuruecksetzenRendered() {
    return hasPermission(UseCasePermission.DOKUMENT_VORLAGE_EDIT) && isWahlOderWahlterminHatStandardVorlagenHinterlegt();
  }

  @Redirect
  public String standardZuruecksetzen() {

    if (isBtnStandardZuruecksetzenRendered() && !isBtnStandardZuruecksetzenDisabled()) {
      List<DokumentArchiveUploadResultEntry> dokumentArchiveUploadResultEntries = defaultDokumentVorlagenInit.setzeDefaultDokumentVorlagenZurueck(getSelectedWahltermin(), getSelectedWahl() );
      if (dokumentArchiveUploadResultEntries.isEmpty()) {
        addWarningMessage("dokument.vorlage.edit.standard.zurueckgesetzt.fehlgeschlagen");
      } else {
        for (DokumentArchiveUploadResultEntry entry : dokumentArchiveUploadResultEntries) {
          if (entry.getStatus().isUploadErfolgt()) {
            addInfoMessage("dokument.vorlage.edit.standard.zurueckgesetzt.info", messages.lokalisiere(entry.getDokumentVorlageArt()),
                entry.getDokumentVorlageName(), messages.lokalisiere(entry.getStatus()));
          } else {
            addWarningMessage("dokument.vorlage.edit.standard.zurueckgesetzt.warn", messages.lokalisiere(entry.getDokumentVorlageArt()),
                entry.getDokumentVorlageName(), messages.lokalisiere(entry.getStatus()));
          }
        }
      }
    }

    return FacesContextUtil.getCurrentViewId();
  }

  protected boolean isWahlOderWahlterminHatStandardVorlagenHinterlegt() {
    return isWahlterminHatStandardVorlagenHinterlegt() || isWahlHatStandardVorlagenHinterlegt();
  }

  private boolean isWahlterminHatStandardVorlagenHinterlegt() {
    return getSelectedWahltermin() != null && getSelectedWahltermin().getDokumentvorlagen().isVorlagenVorhanden();
  }

  private boolean isWahlHatStandardVorlagenHinterlegt() {
    return getSelectedWahl() != null && getSelectedWahl().getWahlart().getDokumentvorlagen().isVorlagenVorhanden();
  }

  public boolean isBtnDownloadAllDisabled() {
    return isEmptySearchResultDisplayed();
  }

  public boolean isBtnStandardZuruecksetzenDisabled() {
    return false;
  }

  public StreamedContent getDownloadAllStreamedContent() {
    return DefaultStreamedContent.builder()
        .stream(() -> new ByteArrayInputStream(search.getDokumentVorlagenAlsZip(getSearchResult())))
        .contentType("application/zip")
        .name(getMessage(DokumentVorlageConstants.MESSAGE_KEY_ENTITY_MEHRZAHL) + "-" + bestimmeWahlOderWahlterminName() + ".zip")
        .build();
  }

  private String bestimmeWahlOderWahlterminName() {
    if (isWahlSelected()) {
      return getSelectedWahl().getName();
    }

    if (isWahlterminSelected()) {
      return getSelectedWahltermin().getName();
    }

    throw new IllegalStateException("Weder Wahl noch Wahltermin ausgewählt");
  }

  @Override
  public void presetSearchParameters() {
    if (isWahlterminSelected()) {
      searchParameters.setWahltermin(getSelectedWahltermin());
    }

    if (isWahlSelected()) {
      searchParameters.setWahl(getSelectedWahl());
    }
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    String wildcardTooltip = getMessage(AbstractSearchParameters.WILDCARD_TOOLTIP_MSG_KEY);

    formBuilder.addProperty(searchParameters.getDokumentVorlageArtProperty());
    formBuilder.addProperty(searchParameters.getDokumentVorlageAnlageArtProperty());
    formBuilder.addProperty(searchParameters.getNameProperty()).withTooltip(wildcardTooltip);
    formBuilder.addProperty(searchParameters.getVersionsnummerProperty()).withTooltip(wildcardTooltip);
  }
}
